# ''' Prepare KITTI data for 3D object detection.
print("DO NOT USE THIS FILE")
# Author: Charles R. Qi
# Date: September 2017
# '''
# from __future__ import print_function

# import os
# import sys
# import numpy as np
# import cv2
# from PIL import Image
# BASE_DIR = os.path.dirname(os.path.abspath(__file__))
# ROOT_DIR = os.path.dirname(BASE_DIR)
# sys.path.append(BASE_DIR)
# sys.path.append(os.path.join(ROOT_DIR, 'mayavi'))
# import kitti_util as utils
# import cPickle as pickle
# from kitti_object import *
# import argparse

# def in_hull(p, hull):
#     from scipy.spatial import Delaunay
#     if not isinstance(hull,Delaunay):
#         hull = Delaunay(hull)
#     return hull.find_simplex(p)>=0

# def extract_pc_in_box3d(pc, box3d):
#     ''' pc: (N,3), box3d: (8,3) '''
#     box3d_roi_inds = in_hull(pc[:,0:3], box3d)
#     return pc[box3d_roi_inds,:], box3d_roi_inds

# def extract_pc_in_box2d(pc, box2d):
#     ''' pc: (N,2), box2d: (xmin,ymin,xmax,ymax) '''
#     box2d_corners = np.zeros((4,2))
#     box2d_corners[0,:] = [box2d[0],box2d[1]] 
#     box2d_corners[1,:] = [box2d[2],box2d[1]] 
#     box2d_corners[2,:] = [box2d[2],box2d[3]] 
#     box2d_corners[3,:] = [box2d[0],box2d[3]] 
#     box2d_roi_inds = in_hull(pc[:,0:2], box2d_corners)
#     return pc[box2d_roi_inds,:], box2d_roi_inds

# def random_shift_box2d(box2d, shift_ratio=0.1):
#     ''' Randomly shift box center, randomly scale width and height 
#     '''
#     r = shift_ratio
#     xmin,ymin,xmax,ymax = box2d
#     h = ymax-ymin
#     w = xmax-xmin
#     cx = (xmin+xmax)/2.0
#     cy = (ymin+ymax)/2.0
#     cx2 = cx + w*r*(np.random.random()*2-1)
#     cy2 = cy + h*r*(np.random.random()*2-1)
#     h2 = h*(1+np.random.random()*2*r-r) # 0.9 to 1.1
#     w2 = w*(1+np.random.random()*2*r-r) # 0.9 to 1.1
#     return np.array([cx2-w2/2.0, cy2-h2/2.0, cx2+w2/2.0, cy2+h2/2.0])

# def read_det_file(det_filename):
#     ''' Parse lines in 2D detection output files '''
#     det_id2str = {1:'Pedestrian', 2:'Car', 3:'Cyclist'}
#     id_list = []
#     type_list = []
#     prob_list = []
#     box2d_list = []
#     for line in open(det_filename, 'r'):
#         t = line.rstrip().split(" ")
#         id_list.append(int(os.path.basename(t[0]).rstrip('.png')))
#         type_list.append(det_id2str[int(t[1])])
#         prob_list.append(float(t[2]))
#         box2d_list.append(np.array([float(t[i]) for i in range(3,7)]))
#     return id_list, type_list, box2d_list, prob_list

# def train_e2e(det_filename, split):
#     x = 1
    

# def create_frustum_pkl_file(det_filename, split, img_height_threshold = 25):
#     ''' Extract point clouds in frustums extruded from 2D detection boxes.
#         Update: Lidar points and 3d boxes are in *rect camera* coord system
#             (as that in 3d box label files)
        
#     Input:
#         det_filename: string, each line is
#             img_path typeid confidence xmin ymin xmax ymax
#         split: string, either trianing or testing
#         output_filename: string, the name for output .pickle file
#         type_whitelist: a list of strings, object types we are interested in.
#         img_height_threshold: int, neglect image with height lower than that.
#         lidar_point_threshold: int, neglect frustum with too few points.
#     Output:
#         None (will write a .pickle file to the disk)
#     '''
#     dataset = kitti_object(os.path.join(ROOT_DIR, 'dataset/KITTI/object'), split)
#     det_id_list, det_type_list, det_box2d_list, det_prob_list = \
#         read_det_file(det_filename)
    
#     master_dict = {}
    
#     for det_idx in range(len(det_id_list)):
        
#         data_idx = det_id_list[det_idx]
#         objects = dataset.get_label_objects(data_idx)
        
#         print('det idx: %d/%d, data idx: %d' % \
#             (det_idx, len(det_id_list), data_idx))
        
#         calib = dataset.get_calibration(data_idx) # 3 by 4 matrix
            
#         ## Everthing precrocessing goes here
#         img = dataset.get_image(data_idx)
#         img_height, img_width, img_channel = img.shape
#         xmin,ymin,xmax,ymax = det_box2d_list[det_idx]
        
#         if ymax-ymin<img_height_threshold:
#             continue
            
#         # Get frustum angle (according to center pixel in 2D BOX)
#         box2d_center = np.array([(xmin+xmax)/2.0, (ymin+ymax)/2.0])
#         uvdepth = np.zeros((1,3))
#         uvdepth[0,0:2] = box2d_center
#         uvdepth[0,2] = 20 # some random depth
#         box2d_center_rect = calib.project_image_to_rect(uvdepth)
#         frustum_angle = -1 * np.arctan2(box2d_center_rect[0,2], box2d_center_rect[0,0])
        
#         master_dict[det_idx] = {
#             "data_idx" : data_idx,
#             "type" : det_type_list[det_idx],
#             "box2d": det_box2d_list[det_idx],
#             "prob" : det_prob_list[det_idx],
#             "frustum_angle" : frustum_angle
#         }
#     output_filename = "frustum_preprocessed_data_" + split + ".pkl"    
#     with open(output_filename,'wb') as fp:
#         pickle.dump(master_dict)
        
# def process_depth(pred_depth_dir, data_idx):
    
#     depth_path = '%s/%06d.npy' % (pred_depth_dir, data_idx)
#     depth_dense = np.load(depth_path)

#     # convert dense depth to pointcloud
#     # data_idx = bild id

#     predUVDepth = np.zeros((np.prod(np.shape(depth_dense)),3))
#     U, V = np.meshgrid(np.arange(0,1242), np.arange(0,375))
#     predUVDepth[:,0] = np.reshape(U, [-1])
#     predUVDepth[:,1] = np.reshape(V, [-1])
#     depth_vec = np.reshape(depth_dense, [-1]) / 721.5377 / 1.62
#     predUVDepth[:,2] = depth_vec

#     # remove invalid depth values (lars)
#     predUVDepth = predUVDepth[np.logical_and(depth_vec>0, depth_vec<150),:]
#     # rectify
#     pc_pred_velo = calib.project_image_to_velo(predUVDepth)
#     pc_pred_rect = calib.project_velo_to_rect(pc_pred_velo)

#     _, pc_image_coord, img_fov_inds = get_lidar_in_image_fov(\
#         pc_pred_velo[:,0:3], calib, 0, 0, img_width, img_height, True)

#     # 2D BOX: Get pts rect backprojected 

#     box_fov_inds = (pc_image_coord[:,0]<xmax) & \
#         (pc_image_coord[:,0]>=xmin) & \
#         (pc_image_coord[:,1]<ymax) & \
#         (pc_image_coord[:,1]>=ymin)
#     box_fov_inds = box_fov_inds & img_fov_inds
#     pc_in_box_fov = pc_pred_rect[box_fov_inds,:]

#     # Pass objects that are too small
#     if len(pc_in_box_fov) < lidar_point_threshold:
#         continue

#     return pc_in_box_fov

# if __name__=='__main__':
    
#     create_frustum_pkl_file(det_filename, split)
    
      
# #     parser = argparse.ArgumentParser()
# #     parser.add_argument('--gen_train', action='store_true', help='Generate train split frustum data with perturbed GT 2D boxes')
# #     parser.add_argument('--gen_val', action='store_true', help='Generate val split frustum data with GT 2D boxes')
# #     parser.add_argument('--gen_val_rgb_detection', action='store_true', help='Generate val split frustum data with RGB detection 2D boxes')
# #     args = parser.parse_args()
    
# #     ###############
# #     model_id = 'monodepth'
# #     model = '2019-02-24_22-48_mono_depth_thinlens_fixed_f8_relu_nochroma_ADAM_{}_0.001_None_50000/'     
# #     pred_depth_dir = '/home/EE367_project/monodepth/real_depth_training/'
# #     ###############

# #     if args.car_only:
# #         type_whitelist = ['Car']
# #         output_prefix = 'frustum_caronly_'
# #     else:
# #         type_whitelist = ['Car', 'Pedestrian', 'Cyclist']
# #         output_prefix = 'pickles/frustum_carpedcyc_lars_'
    
# #     if args.gen_train:
# #         extract_frustum_data(\
# #             os.path.join(BASE_DIR, 'image_sets/train.txt'),
# #             'training',
# #             os.path.join(BASE_DIR, output_prefix+'train.pickle'),
# #             pred_depth_dir,
# #             viz=False, perturb_box2d=True, augmentX=5,
# #             type_whitelist=type_whitelist)

# #     if args.gen_val:
# #         extract_frustum_data(\
# #             os.path.join(BASE_DIR, 'image_sets/val.txt'),
# #             'training',
# #             os.path.join(BASE_DIR, output_prefix+'val.pickle'),
# #             pred_depth_dir,
# #             viz=False, perturb_box2d=False, augmentX=1,
# #             type_whitelist=type_whitelist)

# #     if args.gen_val_rgb_detection:
# #         extract_frustum_data_rgb_detection(\
# #             os.path.join(BASE_DIR, 'rgb_detections/rgb_detection_val.txt'),
# #             'training',
# #             os.path.join(BASE_DIR, output_prefix+'val_rgb_detection.pickle'),
# #             pred_depth_dir,
# #             viz=False,
# #             type_whitelist=type_whitelist) 
